<?
/*
----------------------------------------------------------------
	Site management assistance XML Writer var. 1.0 (UTF-8)
	(C)1999-2006 by CGI工房・かきしちかんぱに～！
             　　     かきしち(尾崎浩昭)
	E-Mail: info@kakisiti.jp
	Home: http://www.kakisiti.jp
----------------------------------------------------------------
*/

// 初期設定 (初期値は設定しなくてもWeb上で変更化)
$url = "http://www.kakisiti.jp/download/";							//	設置URL 初期値
$out_dir = "./sitemap/";			//	出力ディレクトリ 初期値
$sitemap = "sitemap.xml";			//	出力ファイル名 初期値
// -------------------------------------------------------------
// 以下の改造は知識のない方はご遠慮ください。
// -------------------------------------------------------------

$PHP_SELF = $_SERVER[PHP_SELF];
$L_CHANGEFREQ = array('always','hourly','daily','weekly','monthly','yearly','never');
$dir = "./";

if ($_POST) { foreach ($_POST as $key => $val) { $$key = $val; } }
$STATUS_LINE = "$url<>$dir<>$out_dir<>$sitemap<>$htm<>$html<>$php<>$output_mode<>";

// -- check --
list($CHECK_LINE,$error) = status_check($STATUS_LINE);

// -- Done --
if (!$error) {
	if ($_POST[mode] == "Make Sitemap") { list($msg,$error) = make($STATUS_LINE,$skip,$set_changefreq,$set_priority); }
	if ($_POST[mode] == "Make RSS1.0") { list($msg,$error) = make_rss($STATUS_LINE,$skip,$set_changefreq,$set_priority); }
	if ($_POST[mode] == "Make RSS2.0") { list($msg,$error) = make_rss($STATUS_LINE,$skip,$set_changefreq,$set_priority); }
	if ($_POST[mode] == "Make ATOM") { list($msg,$error) = make_rss($STATUS_LINE,$skip,$set_changefreq,$set_priority); }
}

// -- Make html --
$first_set_html .= check_body($STATUS_LINE,$CHECK_LINE);
if ($error) {
	if ($_POST) { $error_html .= "<hr><h2>Error</h2>$msg"; }
} else {
	if ($msg) { $error_html .= "<hr><h2>Announcement</h2>$msg"; }
	if ($output_mode == "sitemap") { list($OPTION_LINE,$second_set_html) = sitemap_option($STATUS_LINE); }
	elseif ($output_mode == "rss1") { list($OPTION_LINE,$second_set_html) = rss_option($STATUS_LINE); }
	elseif ($output_mode == "rss2") { list($OPTION_LINE,$second_set_html) = rss_option($STATUS_LINE); }
	elseif ($output_mode == "atom") { list($OPTION_LINE,$second_set_html) = rss_option($STATUS_LINE); }

	if ($OPTION_LINE) {
		$check_form_html .= check_form($STATUS_LINE,$OPTION_LINE,$skip,$set_changefreq,$set_priority);
	}
}

$HTML = head();
$HTML .= $first_set_html;
$HTML .= $error_html;
$HTML .= $second_set_html;
$HTML .= $check_form_html;
$HTML .= foot();
echo $HTML;
exit;


// -- サブルーチン --

function head() {
	$HTML = <<<EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html lang="ja">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<meta http-equiv="Content-Style-Type" content="text/css">
<title>Site management assistance XML Writer</title>
</head>
<body>
<h1>Site management assistance XML Writer</h1>

EOT;
	return $HTML;
}

function check_body ($STATUS_LINE,$CHECK_LINE) {
	global $PHP_SELF;

	list($url,$dir,$out_dir,$sitemap,$htm,$html,$php,$output_mode) = explode("<>",$STATUS_LINE);
	list($url_msg,$dir_msg,$out_dir_msg,$sitemap_msg,$file_type_msg,$output_mode_msg) = explode("<>",$CHECK_LINE);

	if ($htm) { $checked_htm = " checked"; } else { $checked_htm = ""; }
	if ($html) { $checked_html = " checked"; } else { $checked_html = ""; }
	if ($php) { $checked_php = " checked"; } else { $checked_php = ""; }
	if ($output_mode == "sitemap") { $checked3 = " checked"; $checked4 = ""; $checked5 = ""; $checked6 = ""; }
	elseif ($output_mode == "rss1") { $checked3 = ""; $checked4 = " checked"; $checked5 = ""; $checked6 = ""; }
	elseif ($output_mode == "rss2") { $checked3 = ""; $checked4 = ""; $checked5 = " checked"; $checked6 = ""; }
	elseif ($output_mode == "atom") { $checked3 = ""; $checked4 = ""; $checked5 = ""; $checked6 = " checked"; }
	else { $checked3 = ""; $checked4 = ""; $checked5 = ""; $checked6 = ""; }

	$HTML = <<<EOT
<form action="$PHP_SELF" method="POST">
設置URL：<input type="text" name="url" size="30" value="$url">$url_msg<br>
<input type="hidden" name="dir" size="20" value="$dir">$dir_msg
出力ディレクトリ：<input type="text" name="out_dir" size="20" value="$out_dir">$out_dir_msg<br>
出力ファイル名：<input type="text" name="sitemap" size="20" value="$sitemap">$sitemap_msg<br>
検索対象ファイルタイプ：<input type="checkbox" name="htm" id="htm" value="htm"$checked_htm><label for="htm">.htm</label> : 
<input type="checkbox" name="html" id="html" value="html"$checked_html><label for="html">.html</label> : 
<input type="checkbox" name="php" id="php" value="php"$checked_php><label for="php">.php</label>$file_type_msg<br>
出力モード<input type="radio" name="output_mode" id="output_mode1" value="sitemap"$checked3><label for="output_mode1">Google Site Map</label> : 
<input type="radio" name="output_mode" id="output_mode2" value="rss1"$checked4><label for="output_mode2">RSS1.0</label> : 
<input type="radio" name="output_mode" id="output_mode3" value="rss2"$checked5><label for="output_mode3">RSS2.0</label> : 
<input type="radio" name="output_mode" id="output_mode4" value="atom"$checked6><label for="output_mode4">ATOM</label>$output_mode_msg<br>
<input type="submit" name="mode" value="Set">
</form>

EOT;
	return $HTML;
}

function sitemap_option($STATUS_LINE) {
	global $PHP_SELF;

	list($url,$dir,$out_dir,$sitemap,$htm,$html,$php,$output_mode) = explode("<>",$STATUS_LINE);

	if ($_POST[change_dir]) { $check1 = " checked"; } else { $check1 = ""; }
	if ($_POST[change_file]) { $check2 = " checked"; } else { $check2 = ""; }
	if ($_POST[index_omission]) { $check3 = " checked"; } else { $check3 = ""; }
	if ($_POST[include_lastmod]) { $check4 = " checked"; } else { $check4 = ""; }
	if ($_POST[include_changefreq]) { $check5 = " checked"; } else { $check5 = ""; }
	if ($_POST[include_priority]) { $check6 = " checked"; } else { $check6 = ""; }

	$HTML .= "<hr><h2>Google Sitemap Output Option</h2>\n";
	$HTML .= "<form action=\"$PHP_SELF\" method=\"POST\">\n";
	$HTML .= "<input type=\"hidden\" name=\"option_set\" value=\"1\">\n";
	$HTML .= "<input type=\"hidden\" name=\"url\" value=\"$url\">\n";
	$HTML .= "<input type=\"hidden\" name=\"dir\" value=\"$dir\">\n";
	$HTML .= "<input type=\"hidden\" name=\"out_dir\" value=\"$out_dir\">\n";
	$HTML .= "<input type=\"hidden\" name=\"sitemap\" value=\"$sitemap\">\n";
	$HTML .= "<input type=\"hidden\" name=\"htm\" value=\"$htm\">\n";
	$HTML .= "<input type=\"hidden\" name=\"html\" value=\"$html\">\n";
	$HTML .= "<input type=\"hidden\" name=\"php\" value=\"$php\">\n";
	$HTML .= "<input type=\"hidden\" name=\"output_mode\" value=\"$output_mode\">\n";
	$HTML .=<<<EOT
<input type="checkbox" id="change_dir" name="change_dir" value="1"$check1>
<label for="change_dir">検索対象ディレクトリを指定する</label><br>
<input type="checkbox" id="change_file" name="change_file" value="1"$check2>
<label for="change_file">出力ファイルリストを指定する</label><br>
<input type="checkbox" id="index_omission" name="index_omission" value="1"$check3>
<label for="index_omission">indexファイルはファイル名を省略してURLを生成する</label><br>
<input type="checkbox" id="include_lastmod" name="include_lastmod" value="1"$check4>
<label for="include_lastmod">lastmod(最終更新日)を含める</label><br>
<input type="checkbox" id="include_changefreq" name="include_changefreq" value="1"$check5>
<label for="include_changefreq">changefreq(ページの更新頻度)を含める</label><br>
<input type="checkbox" id="include_priority" name="include_priority" value="1"$check6>
<label for="include_priority">priority(URL の優先度)を含める</label><br>

EOT;
	$HTML .= "<input type=\"submit\" value=\"Set\">\n";
	$HTML .= "</form>\n";

	if ($_POST[option_set]) {
		$OPTION_LINE = "$_POST[option_set]<>";
		$OPTION_LINE .= "$_POST[change_dir]<>";
		$OPTION_LINE .= "$_POST[change_file]<>";
		$OPTION_LINE .= "$_POST[index_omission]<>";
		$OPTION_LINE .= "$_POST[include_lastmod]<>";
		$OPTION_LINE .= "$_POST[include_changefreq]<>";
		$OPTION_LINE .= "$_POST[include_priority]<>";
	}

	return array($OPTION_LINE,$HTML);
}

function rss_option($STATUS_LINE) {
	global $PHP_SELF;

	list($url,$dir,$out_dir,$sitemap,$htm,$html,$php,$output_mode) = explode("<>",$STATUS_LINE);

	if ($output_mode == "rss1") { $option_title = "RSS 1.0 Output Option"; }
	elseif ($output_mode == "rss2") { $option_title = "RSS 2.0 Output Option"; }
	elseif ($output_mode == "atom") { $option_title = "ATOM Output Option"; }
	if ($_POST[write_mode]) {
		$check4 = " checked";
		$_POST[change_dir] = $_POST[change_file] = "";
	} else { $check4 = ""; }
	if ($_POST[change_dir]) { $check1 = " checked"; } else { $check1 = ""; }
	if ($_POST[change_file]) { $check2 = " checked"; } else { $check2 = ""; }
	if ($_POST[index_omission]) { $check3 = " checked"; } else { $check3 = ""; }

	$item_count_html = "<select name=\"item_count\">\n";
	for ($i=1;$i<=10;$i++) {
		if ($i == $_POST[item_count]) { $sel = " selected"; } else { $sel = ""; }
		$item_count_html .= "<option value=\"$i\" $sel>$i</option>\n";
	}
	$item_count_html .= "</select>";

	$HTML .= "<hr><h2>$option_title</h2>\n";
	$HTML .= "<form action=\"$PHP_SELF\" method=\"POST\">\n";
	$HTML .= "<input type=\"hidden\" name=\"option_set\" value=\"1\">\n";
	$HTML .= "<input type=\"hidden\" name=\"url\" value=\"$url\">\n";
	$HTML .= "<input type=\"hidden\" name=\"dir\" value=\"$dir\">\n";
	$HTML .= "<input type=\"hidden\" name=\"out_dir\" value=\"$out_dir\">\n";
	$HTML .= "<input type=\"hidden\" name=\"sitemap\" value=\"$sitemap\">\n";
	$HTML .= "<input type=\"hidden\" name=\"htm\" value=\"$htm\">\n";
	$HTML .= "<input type=\"hidden\" name=\"html\" value=\"$html\">\n";
	$HTML .= "<input type=\"hidden\" name=\"php\" value=\"$php\">\n";
	$HTML .= "<input type=\"hidden\" name=\"output_mode\" value=\"$output_mode\">\n";
	$HTML .=<<<EOT
<input type="checkbox" id="write_mode" name="write_mode" value="1"$check4>
<label for="write_mode">自動検索を行わず、手書き出力する</label><br>
$item_count_html
ITEM出力数1～10<br>
<input type="checkbox" id="change_dir" name="change_dir" value="1"$check1>
<label for="change_dir">検索対象ディレクトリを指定する</label><br>
<input type="checkbox" id="change_file" name="change_file" value="1"$check2>
<label for="change_file">出力ファイルリストを指定する</label><br>

EOT;
	$HTML .= "<input type=\"submit\" value=\"Set\">\n";
	$HTML .= "</form>\n";

	if ($_POST[option_set]) {
		$OPTION_LINE = "$_POST[option_set]<>";
		$OPTION_LINE .= "$_POST[change_dir]<>";
		$OPTION_LINE .= "$_POST[change_file]<>";
		$OPTION_LINE .= "$_POST[index_omission]<>";
		$OPTION_LINE .= "$_POST[include_lastmod]<>";
		$OPTION_LINE .= "$_POST[include_changefreq]<>";
		$OPTION_LINE .= "$_POST[include_priority]<>";
		$OPTION_LINE .= "$_POST[write_mode]<>";
		$OPTION_LINE .= "$_POST[item_count]<>";
	}

	return array($OPTION_LINE,$HTML);
}

function check_form($STATUS_LINE,$OPTION_LINE,$skip,$set_changefreq,$set_priority) {
	global $PHP_SELF,$L_CHANGEFREQ;

	list($url,$dir,$out_dir,$sitemap,$htm,$html,$php,$output_mode) = explode("<>",$STATUS_LINE);
	list($option_set,$change_dir,$change_file,$index_omission,$include_lastmod,$include_changefreq,$include_priority,$write_mode,$item_count)
	= explode("<>",$OPTION_LINE);

	if ($output_mode == "sitemap") { $button_name = "Make Sitemap"; }
	elseif ($output_mode == "rss1") { $button_name = "Make RSS1.0"; }
	elseif ($output_mode == "rss2") { $button_name = "Make RSS2.0"; }
	elseif ($output_mode == "atom") { $button_name = "Make ATOM"; }

	if ($set_changefreq) {
		foreach ($set_changefreq as $val) {
			if (!$val) { continue; }
			else {
				list($target,$value) = explode("<>",$val);
				$L_SET_CHANGEFREQ[$target] = $value;
				$HIDDEN .= "<input type=\"hidden\" name=\"set_changefreq[]\" value=\"$val\">\n";
			}
		}
	}

	if ($set_priority) {
		foreach ($set_priority as $val) {
			if (!$val) { continue; }
			else {
				list($target,$value) = explode("<>",$val);
				$L_SET_PRIORITY[$target] = $value;
				$HIDDEN .= "<input type=\"hidden\" name=\"set_priority[]\" value=\"$val\">\n";
			}
		}
	}

	$HIDDEN .= "<input type=\"hidden\" name=\"url\" value=\"$url\">\n";
	$HIDDEN .= "<input type=\"hidden\" name=\"dir\" value=\"$dir\">\n";
	$HIDDEN .= "<input type=\"hidden\" name=\"out_dir\" value=\"$out_dir\">\n";
	$HIDDEN .= "<input type=\"hidden\" name=\"sitemap\" value=\"$sitemap\">\n";
	$HIDDEN .= "<input type=\"hidden\" name=\"htm\" value=\"$htm\">\n";
	$HIDDEN .= "<input type=\"hidden\" name=\"html\" value=\"$html\">\n";
	$HIDDEN .= "<input type=\"hidden\" name=\"php\" value=\"$php\">\n";
	$HIDDEN .= "<input type=\"hidden\" name=\"output_mode\" value=\"$output_mode\">\n";
	$HIDDEN .= "<input type=\"hidden\" name=\"option_set\" value=\"$option_set\">\n";
	$HIDDEN .= "<input type=\"hidden\" name=\"change_dir\" value=\"$change_dir\">\n";
	$HIDDEN .= "<input type=\"hidden\" name=\"change_file\" value=\"$change_file\">\n";
	$HIDDEN .= "<input type=\"hidden\" name=\"index_omission\" value=\"$index_omission\">\n";
	$HIDDEN .= "<input type=\"hidden\" name=\"include_lastmod\" value=\"$include_lastmod\">\n";
	$HIDDEN .= "<input type=\"hidden\" name=\"include_changefreq\" value=\"$include_changefreq\">\n";
	$HIDDEN .= "<input type=\"hidden\" name=\"include_priority\" value=\"$include_priority\">\n";
	$HIDDEN .= "<input type=\"hidden\" name=\"item_count\" value=\"$item_count\">\n";

	if ($change_dir) {
		$HTML = "<hr><h2>対象ディレクトリリスト</h2>\n";
		$HTML .= "<p>SiteMap対象外にしたいディレクトリにはチェックを入れてください。</p>\n";
		$HTML .= "<form action=\"$PHP_SELF\" method=\"POST\">\n";
		$HTML .= "<input type=\"hidden\" name=\"mode\" value=\"skipset\">\n";
		if (is_array($skip)) {
			foreach ($skip as $skip_path) {
				$HIDDEN .= "<input type=\"hidden\" name=\"skip[]\" value=\"$skip_path\">\n";
			}
		}
		$HTML .= $HIDDEN;
		$DIR = make_dir($STATUS_LINE,$dir,$skip);
		if ($DIR) {
			sort($DIR);
			$hierarchy_count_old = 1;
			foreach ($DIR as $val) {
				$hierarchy = explode("/",$val);
				$hierarchy_count = count($hierarchy);
				if ($hierarchy_count_old < $hierarchy_count) {
					$HTML .= "<ul>\n";
					$hierarchy_count_old = $hierarchy_count;
				}
				$id = "";
				if ($hierarchy) {
					foreach ($hierarchy as $val2) {
						if ($val2 != ".") { $id .= $val2; }
					}
				}
				if ($hierarchy_count_old > $hierarchy_count) {
					for ($i=0;$i<$hierarchy_count_old - $hierarchy_count+1;$i++) {
						$HTML .= "</ul>\n";
					}
						$HTML .= "<ul>\n";
					$hierarchy_count_old = $hierarchy_count;
				}

				$HTML .= "<li><input type=\"checkbox\" name=\"skip[]\" id=\"$id\" value=\"$val\">";
				$HTML .= "<label for=\"$id\">" . $hierarchy[$hierarchy_count-2] . "</label>\n";
				if ($include_changefreq) {
					$HTML .= "<select name=\"set_changefreq[]\">\n";
					$HTML .= "<option value=\"\">#--Set changefreq--</option>\n";
					foreach ($L_CHANGEFREQ as $val_changefreq) {
						if ($L_SET_CHANGEFREQ[$val] && $val_changefreq == $L_SET_CHANGEFREQ[$val]) { $sel = " selected"; } else { $sel = ""; }
						$select_value = $val . "<>" . $val_changefreq;
						$HTML .= "<option value=\"$select_value\"$sel>$val_changefreq</option>\n";
					}
					$HTML .= "</select>\n";
				}
				if ($include_priority) {
					$HTML .= "<select name=\"set_priority[]\">\n";
					$HTML .= "<option value=\"\">#--Set priority--</option>\n";
					for ($i=1;$i<=10;$i++) {
						$val_priority = $i * 0.1;
						if ($i == $L_SET_PRIORITY[$val]) { $sel = " selected"; } else { $sel = ""; }
						$select_value = $val . "<>" . $i;
						$HTML .= "<option value=\"$select_value\"$sel>" . $val_priority . "</option>\n";
					}
					$HTML .= "</select>\n";
				}
			}
			for ($i=0;$i<$hierarchy_count_old - $hierarchy_count+1;$i++) {
				$HTML .= "</ul>\n";
			}

			$dir_count = count($DIR);
		}
		$HTML .= "<input type=\"submit\" value=\"Set\">\n";
		$HTML .= "<input type=\"submit\" name=\"mode\" value=\"$button_name\">\n";
		$HTML .= "</form>\n";
	}

	if ($change_file) {
		$HTML .= "<hr><h2>対象ファイルリスト</h2>\n";
		$HTML .= "<p>SiteMap対象外にしたいファイルはチェックを入れてSetボタンをクリックしてください。<br>\n";
		$HTML .= "表示されているURLでよければ、Make Sitemapボタンをクリックしてください。</p>\n";
		$HTML .= "<form action=\"$PHP_SELF\" method=\"POST\">\n";
		$HTML .= "<input type=\"hidden\" name=\"mode\" value=\"skipset\">\n";
		$HTML .= $HIDDEN;

		$FILE = make_url($STATUS_LINE,$dir,$skip);

		if ($FILE) {
			sort($FILE);
			foreach ($FILE as $val) {
				$skip_val = ereg_replace($url,"./",$val);
				$HTML .= "<input type=\"checkbox\" name=\"skip[]\" id=\"$val\" value=\"$skip_val\">";
				if ($index_omission) {
					if (ereg("index.(.*)$",$val,$ext)) {
						$output_url = ereg_replace("index.$ext[1]","",$val);
					} else {
						$output_url = $val;
					}
				} else {
					$output_url = $val;
				}
				$HTML .= "<label for=\"$val\">" . $output_url . "</label>\n";
				if ($include_changefreq) {
					$HTML .= "<select name=\"set_changefreq[]\">\n";
					$HTML .= "<option value=\"\">#--Set changefreq--</option>\n";
					foreach ($L_CHANGEFREQ as $val_changefreq) {
						if ($L_SET_CHANGEFREQ[$val] && $val_changefreq == $L_SET_CHANGEFREQ[$val]) { $sel = " selected"; } else { $sel = ""; }
						$select_value = $val . "<>" . $val_changefreq;
						$HTML .= "<option value=\"$select_value\"$sel>$val_changefreq</option>\n";
					}
					$HTML .= "</select>\n";
				}
				if ($include_priority) {
					$HTML .= "<select name=\"set_priority[]\">\n";
					$HTML .= "<option value=\"\">#--Set priority--</option>\n";
					for ($i=1;$i<=10;$i++) {
						$val_priority = $i * 0.1;
						if ($i == $L_SET_PRIORITY[$val]) { $sel = " selected"; } else { $sel = ""; }
						$select_value = $val . "<>" . $i;
						$HTML .= "<option value=\"$select_value\"$sel>" . $val_priority . "</option>\n";
					}
					$HTML .= "</select>\n";
				}
				$HTML .= "<br>\n";
			}
			$link_count = count($FILE);
		} else {
			$HTML .= "<p style=\"color:#cc0000\">ファイルが存在しません。</p>\n";
		}

		$HTML .= "Sitemap対象URL数 : " . $link_count . "件<br>\n";
		$HTML .= "<input type=\"submit\" value=\"Set\">\n";
		$HTML .= "<input type=\"submit\" name=\"mode\" value=\"$button_name\">\n";
		$HTML .= "</form>\n";
	}

	if ($write_mode) {

		$channel = $url . ereg_replace("\./","",$out_dir) . $sitemap;
		if ($_POST[channel]) { $channel = $_POST[channel]; }
		if ($_POST[url]) { $url = $_POST[url]; }
		if ($_POST[title]) { $title = $_POST[title]; }
		if ($_POST[description]) { $description = $_POST[description]; }

		$HTML .= "<hr><h2>手書き出力</h2>\n";
		$HTML .= "<p>下記の必要事項を入力し、Make RSS1.0ボタンをクリックしてください。</p>\n";
		$HTML .= "<form action=\"$PHP_SELF\" method=\"POST\">\n";
		$HTML .= "<input type=\"hidden\" name=\"mode\" value=\"skipset\">\n";
		$HTML .= "<input type=\"hidden\" name=\"write_mode\" value=\"1\">\n";
		$HTML .= "<input type=\"hidden\" name=\"item_count\" value=\"$item_count\">\n";
		$HTML .= $HIDDEN;

		$HTML .=<<<EOT
<h3>ウェブサイトの設定</h3>
RSSファイルのURL<br>
<input type="text" name="channel" size="50" value="$channel"><br>
Webサイト(ホームページ)のURL<br>
<input type="text" name="link" size="50" value="$url"><br>
Webサイト(ホームページ)のタイトル<br>
<input type="text" name="title" size="50" value="$title"><br>
Webサイト(ホームページ)の説明/概要<br>
<input type="text" name="description" size="50" value="$description"><br>
<h3>更新内容の設定</h3>
EOT;
		for ($i=1;$i<=$item_count;$i++) {
			$link_name = "link_" . $i;
			$title_name = "title_" . $i;
			$description_name = "description_" . $i;
			if ($_POST[$link_name]) { $$link_name = $_POST[$link_name]; }
			if ($_POST[$title_name]) { $$title_name = $_POST[$title_name]; }
			if ($_POST[$description_name]) { $$description_name = $_POST[$description_name]; }
			$HTML .=<<<EOT
<p style="border-width : 2px 2px 2px 2px;border-color:#cccccc #cccccc #cccccc #cccccc;border-style : solid solid solid solid;padding : 2px 2px 2px 2px;">
更新コンテンツのURL (その$i)<br>
<input type="text" name="$link_name" size="50" value="${$link_name}"><br>
更新コンテンツのタイトル (その$i)<br>
<input type="text" name="$title_name" size="50" value="${$title_name}"><br>
更新コンテンツの説明/概要 (その$i)<br>
<input type="text" name="$description_name" size="50" value="${$description_name}"><br>
</p>

EOT;
		}


		$HTML .= "<input type=\"submit\" name=\"mode\" value=\"Make RSS1.0\">\n";
		$HTML .= "</form>\n";
	}

	return $HTML;
}

function make_dir($STATUS_LINE,$DIR_LIST,$skip) {
	list($url,$dir,$out_dir,$sitemap,$htm,$html,$php,$output_mode) = explode("<>",$STATUS_LINE);
	if ($DIR_LIST) {
		if (is_dir($DIR_LIST)) {
			if ($dh = opendir($DIR_LIST)) {
				while (($file = readdir($dh)) !== false) {
					if ($file == "."||$file == "..") { continue; }
					if (filetype("$DIR_LIST$file") == "dir") {

						$DIR_NAME = "$DIR_LIST$file"."/";
						if (is_array($skip)) {
							$skip_flag = 0;
							foreach ($skip as $skip_path) {
								if (ereg($skip_path,$DIR_NAME)) { $skip_flag = 1; break; }
							}
						}
						if ($skip_flag == 1) { continue; }

						$DIR[] = $DIR_NAME;
						$NEW_DIR = make_dir($STATUS_LINE,$DIR_NAME,$skip);
						$DIR = array_merge($DIR,$NEW_DIR);
						continue;
					}
				}
				closedir($dh);
			}
		}
	}
	return $DIR;
}

function make_url($STATUS_LINE,$DIR_LIST,$skip) {
	global $PHP_SELF;

	list($url,$dir,$out_dir,$sitemap,$htm,$html,$php,$output_mode) = explode("<>",$STATUS_LINE);
	if ($DIR_LIST) {
		if (is_dir($DIR_LIST)) {
			if ($dh = opendir($DIR_LIST)) {
				while (($file = readdir($dh)) !== false) {
					if ($file == "."||$file == "..") { continue; }

					$DIR_NAME = "$DIR_LIST$file"."/";
					if (is_array($skip)) {
						$skip_flag = 0;
						foreach ($skip as $skip_path) {
							if (ereg($skip_path,$DIR_NAME)) { $skip_flag = 1; break; }
						}
					}
					if ($skip_flag == 1) { continue; }

					if (filetype("$DIR_LIST$file") == "dir") {
						$DIR[] = $file;
						$NEW_FILE = make_url($STATUS_LINE,$DIR_NAME,$skip);
						$FILE = array_merge($FILE,$NEW_FILE);
						continue;
					}

					if (ereg("^./",$DIR_LIST)) { $add_dir = ereg_replace("\./","",$DIR_LIST); }
					elseif (ereg("^/(.*)",$DIR_LIST,$key)) { $add_dir = $key[1]; }
					else { $add_dir = $DIR_LIST; }
					if (!$htm && !$html && !$php) { break; }
					if (!ereg(".htm$",$file) && !ereg(".html$",$file) && !ereg(".php$",$file)) { continue; }
					if ($htm) { if (ereg(".htm$",$file)) { $FILE[] = $url . $add_dir . $file; } }
					if ($html) { if (ereg(".html$",$file)) { $FILE[] = $url . $add_dir . $file; } }
					if ($php) { if (ereg(".php$",$file)) { $FILE[] = $url . $add_dir . $file; } }
				}
				closedir($dh);
			}
		}
	}
	return $FILE;
}

function foot() {
	$HTML = <<<EOT
<div align="right"><a href="http://www.kakisiti.jp/">Powered by CGI工房 かきしちかんぱに～！</a></div>
</body>
</html>

EOT;
	return $HTML;
}

function status_check($STATUS_LINE) {
	list($url,$dir,$out_dir,$sitemap,$htm,$html,$php,$output_mode) = explode("<>",$STATUS_LINE);

	if (!$url) {
 		$error = 1;
		$url_msg = "<span style=\"color:#cc0000;\">設置URLを入力してください。</span>";
	}
	if (!ereg("/$",$url)) {
		$error = 1;
		$url_msg = "<span style=\"color:#cc0000;\">設置URLの最後は[/]でお願いします。</span>";
	}
	if (!is_dir($dir)) {
		$error = 1;
		$dir_msg = "<span style=\"color:#cc0000;\">ディレクトリの存在が確認できません。</span>";
	}
	if (ereg("\../",$out_dir)) {
		$error = 1;
		$out_dir_msg = "<span style=\"color:#cc0000;\">設置ディレクトリより上位のディレクトリは参照できません。</span>";
	}
	if (!ereg("^\./",$out_dir)) {
		$error = 1;
		$out_dir_msg = "<span style=\"color:#cc0000;\">出力ディレクトリが書き出しは[./]でお願いします。</span>";
	}
	if (!ereg("/$",$out_dir)) {
		$error = 1;
		$out_dir_msg = "<span style=\"color:#cc0000;\">出力ディレクトリの最後は[/]でお願いします。</span>";
	}
	if (is_dir($out_dir) && !$out_dir_msg) {
		if (is_writable($out_dir)) {
			$out_dir_msg = "<span style=\"color:#0000cc;\">正常</span>"; 
		} else {
			$error = 1;
			$out_dir_msg = "<span style=\"color:#cc0000;\">ディレクトリが書き込み不可です。</span>";
		}
	} else {
		$error = 1;
		if (!$out_dir_msg) {
			$out_dir_msg = "<span style=\"color:#cc0000;\">ディレクトリの存在が確認できません。</span>";
		}
	}
	if (!$sitemap) {
 			$sitemap_msg = "<span style=\"color:#cc0000;\">出力ファイル名を入力してください。</span>";
	}
	if (!$htm && !$html && !$php) {
		$error = 1;
		$file_type_msg = "<span style=\"color:#cc0000;\">出力対象ファイルタイプを指定してください。</span>";
	}
	if (!$output_mode) {
		$error = 1;
		$output_mode_msg = "<span style=\"color:#cc0000;\">出力モードを指定してください。</span>";
	}
	if ($output_mode != "sitemap" && $php) {
 			$file_type_msg .= "<span style=\"color:#cc0000;\">Google Site Map以外は.phpを選択できません。</span>";
	}
	$CHECK_LINE = "$url_msg<>$dir_msg<>$out_dir_msg<>$sitemap_msg<>$file_type_msg<>$output_mode_msg<>";
	return array($CHECK_LINE,$error);
}

function make($STATUS_LINE,$skip,$set_changefreq,$set_priority) {

	list($url,$dir,$out_dir,$sitemap,$htm,$html,$php,$output_mode) = explode("<>",$STATUS_LINE);
	if ($_POST[option_set]) {
		$option_set = "$_POST[option_set]";
		$change_dir = "$_POST[change_dir]";
		$change_file = "$_POST[change_file]";
		$index_omission = "$_POST[index_omission]";
		$include_lastmod = "$_POST[include_lastmod]";
		$include_changefreq = "$_POST[include_changefreq]";
		$include_priority = "$_POST[include_priority]";
	}

	if ($set_changefreq) {
		foreach ($set_changefreq as $val) {
			if (!$val) { continue; }
			else {
				list($target,$value) = explode("<>",$val);
				$L_SET_CHANGEFREQ[$target] = $value;
				$HIDDEN .= "<input type=\"hidden\" name=\"set_changefreq[]\" value=\"$val\">\n";
			}
		}
	}

	if ($set_priority) {
		foreach ($set_priority as $val) {
			if (!$val) { continue; }
			else {
				list($target,$value) = explode("<>",$val);
				$L_SET_PRIORITY[$target] = $value;
				$HIDDEN .= "<input type=\"hidden\" name=\"set_priority[]\" value=\"$val\">\n";
			}
		}
	}

	$FILE = make_url($STATUS_LINE,$dir,$skip);
	if ($FILE) {
		$XML[] = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		$XML[] = "<urlset xmlns=\"http://www.google.com/schemas/sitemap/0.84\">\n";

		sort($FILE);
		foreach ($FILE as $val) {
			if ($index_omission) {
				if (ereg("index.(.*)$",$val,$ext)) {
					$output_url = ereg_replace("index.$ext[1]","",$val);
				} else {
					$output_url = $val;
				}
			} else {
				$output_url = $val;
			}
			if ($include_lastmod) {
			}

			$XML[] = "\t<url>\n";
			$XML[] = "\t\t<loc>$output_url</loc>\n";
			if ($include_lastmod) {
				$lastmod_head = date("Y-m-d",filemtime(ereg_replace($url,"./",$val)));
				$lastmod_foot = date("H:i:sO",filemtime(ereg_replace($url,"./",$val)));
				$lastmod = $lastmod_head . "T" . $lastmod_foot;
				$XML[] = "\t\t<lastmod>$lastmod</lastmod>\n";
			}
			if ($include_changefreq && $set_changefreq && $L_SET_CHANGEFREQ) {
				$key = ereg_replace($url,"./",$val);
				foreach ($L_SET_CHANGEFREQ as $KEY => $VAL) {
					if (ereg($KEY,$key)) { $changefreq = $VAL; break; }
				}
				if ($L_SET_CHANGEFREQ[$val]) { $changefreq = $L_SET_CHANGEFREQ[$val]; }
				if ($changefreq) { $XML[] = "\t\t<changefreq>$changefreq</changefreq>\n"; }
				unset($changefreq);
			}
			if ($include_priority && $set_priority && $L_SET_PRIORITY) {
				$key = ereg_replace($url,"./",$val);
				foreach ($L_SET_PRIORITY as $KEY => $VAL) {
					if (ereg($KEY,$key)) { $priority = $VAL * 0.1; break; }
				}
				if ($L_SET_PRIORITY[$val]) { $priority = $L_SET_PRIORITY[$val] * 0.1; }
				if ($priority) { $XML[] = "\t\t<priority>$priority</priority>\n"; }
				unset($priority);
			}
			$XML[] = "\t</url>\n";
		}
		$XML[] = "</urlset>\n";
	} else {
		$msg .= "<p style=\"color:#cc0000\">出力するURLが存在しません。</p>\n";
	}
	if ($XML) {
		$out_path = $out_dir . $sitemap;
		if ($fno = fopen("$out_path", 'w')) {
			foreach ($XML as $val) {
				fwrite($fno, $val, 150000);
			}
		} else {
			$msg .= "<p style=\"color:#cc0000\">Sitemap出力に失敗しました。</p>\n";
		}
		fclose($fno);
	}

	if (!$msg) { $msg = "<p>SiteMapが作成されました。<br><a href=\"$out_path\" target=\"_blank\">$out_path</a></p>"; }
	else { $error = 1; }

	return array($msg,$error);
}

function make_rss($STATUS_LINE,$skip) {
	list($url,$dir,$out_dir,$sitemap,$htm,$html,$php,$output_mode) = explode("<>",$STATUS_LINE);

	$item_count = $_POST[item_count];
	if ($_POST[write_mode]) {
		$channel = $_POST[channel];
		$link = $_POST[link];
		$title = $_POST[title];
		$description = $_POST[description];
	} else {
		if ($htm) { $ext = "htm"; }
		elseif ($html) { $ext = "html"; }
		elseif ($php) { $ext = "php"; }
		$link = $url;
		$channel = $url . ereg_replace("\./","",$out_dir) . $sitemap;
		$index_file = $url . "index." . $ext;
		$title = get_title($url,$index_file);
		$meta = get_meta_tags($link);
		$description = mb_convert_encoding($meta[description], "UTF-8", "auto");
	}

	$XML[] = "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n";
	if ($output_mode == "rss1") {
		$XML[] = "<rdf:RDF\n";
		$XML[] = "\txmlns=\"http://purl.org/rss/1.0/\"\n";
		$XML[] = "\txmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"\n";
		$XML[] = "\txmlns:dc=\"http://purl.org/dc/elements/1.1/\"\n";
		$XML[] = "\txml:lang=\"ja\">\n\n";
		$XML[] = "\t<channel rdf:about=\"$channel\">\n";



	} elseif ($output_mode == "rss2") {
		$XML[] = "<rss version=\"2.0\">\n";
		$XML[] = "\t<channel>\n";
	} elseif ($output_mode == "atom") {
		$XML[] = "<feed xmlns=\"http://www.w3.org/2005/Atom\">\n";
	}
	$XML[] = "\t\t<title>$title</title>\n";
	if ($output_mode == "rss1"||$output_mode == "rss2") { $XML[] = "\t\t<link>$link</link>\n"; }
	elseif ($output_mode == "atom") { $XML[] = "\t\t<link rel=\"alternate\" type=\"text/html\" href=\"$link\" />\n"; }
	if ($output_mode == "rss1") {
		$XML[] = "\t\t<description>$description</description>\n";
		$XML[] = "\t\t<dc:language>ja</dc:language>\n";
	} elseif ($output_mode == "rss2") {
		$XML[] = "\t\t<description>$description</description>\n";
		$XML[] = "\t\t<language>ja</language>\n";
	} elseif ($output_mode == "atom") {
		$XML[] = "\t\t<subtitle>$description</subtitle>\n";
	}

	if ($output_mode == "rss1") {
		$XML[] = "\t\t<items>\n";
		$XML[] = "\t\t\t<rdf:Seq>\n";
	}
	if ($_POST[write_mode]) {
		for ($i=1;$i<=$item_count;$i++) {
			$link_name = "link_" . $i;
			$title_name = "title_" . $i;
			$description_name = "description_" . $i;
			if ($_POST[$link_name]) { $$link_name = $_POST[$link_name]; }
			if ($_POST[$title_name]) { $$title_name = $_POST[$title_name]; }
			if ($_POST[$description_name]) { $$description_name = $_POST[$description_name]; }

			if ($output_mode == "rss1") {
				$XML[] = "\t\t\t\t<rdf:li rdf:resource=\"${$link_name}\"/>\n";
			}
		}
	} else {
		$FILE = make_url($STATUS_LINE,$dir,$skip);
		if ($FILE) {
			foreach ($FILE as $key => $val) {
				$lastmod = filemtime(ereg_replace($url,"./",$val));
				$NEW_LIST[] = "$lastmod<>$val";
			}
			rsort($NEW_LIST);
			for ($i=0;$i<$item_count;$i++) {
				list($val,$link) = explode("<>",$NEW_LIST[$i]);
				if ($output_mode == "rss1") {
					$XML[] = "\t\t\t\t<rdf:li rdf:resource=\"$link\"/>\n";
				}
			}
		}
	}
	if ($output_mode == "rss1") {
		$XML[] = "\t\t\t</rdf:Seq>\n";
		$XML[] = "\t\t</items>\n";
		$XML[] = "\t</channel>\n\n";
	}

	if ($_POST[write_mode]) {
		for ($i=1;$i<=$item_count;$i++) {
			$link_name = "link_" . $i;
			$title_name = "title_" . $i;
			$description_name = "description_" . $i;
			if ($_POST[$link_name]) { $$link_name = $_POST[$link_name]; }
			if ($_POST[$title_name]) { $$title_name = $_POST[$title_name]; }
			if ($_POST[$description_name]) { $$description_name = $_POST[$description_name]; }
			$lastmod_head = date("Y-m-d",filemtime(ereg_replace($url,"./",$$link_name)));
			$lastmod_foot = date("H:i:sO",filemtime(ereg_replace($url,"./",$$link_name)));
			$lastmod = $lastmod_head . "T" . $lastmod_foot;

			if ($output_mode == "rss1") {
				$XML[] = "\t<item rdf:about=\"${$link_name}\">\n";
			} elseif ($output_mode == "rss2") {
				$XML[] = "\t<item>\n";
			} elseif ($output_mode == "atom") {
				$XML[] = "\t<entry>\n";
			}
			$XML[] = "\t\t<title>${$title_name}</title>\n";
			if ($output_mode == "rss1"||$output_mode == "rss2") { $XML[] = "\t\t<link>${$link_name}</link>\n"; }
			elseif ($output_mode == "atom") { $XML[] = "\t\t<link rel=\"alternate\" type=\"text/html\" href=\"${$link_name}\" />\n"; }
			if ($output_mode == "rss1" || $output_mode == "rss2") {
				$XML[] = "\t\t<description>${$description_name}</description>\n";
			} elseif ($output_mode == "atom") {
				$XML[] = "\t\t<summary>${$description_name}</summary>\n";
			}
			if ($output_mode == "rss1") {
				$XML[] = "\t\t<dc:date>$lastmod</dc:date>\n";
			} elseif ($output_mode == "rss2") {
				$XML[] = "\t\t<pubDate>$lastmod</pubDate>\n";
			} elseif ($output_mode == "atom") {
				$XML[] = "\t\t<published>$lastmod</published>\n\n";
			} 
			if ($output_mode == "rss1" || $output_mode == "rss2") {
				$XML[] = "\t</item>\n";
			} elseif ($output_mode == "atom") {
				$XML[] = "\t</entry>\n";
			}
			$XML[] = "\t\n\n";
		}
		if ($output_mode == "rss1") {
			$XML[] = "</rdf:RDF>\n";
		}
	} else {
		if ($item_count > count($NEW_LIST)) { $item_count = count($NEW_LIST); }
		for ($i=0;$i<$item_count;$i++) {
			list($val,$link) = explode("<>",$NEW_LIST[$i]);
			$lastmod_head = date("Y-m-d",$val);
			$lastmod_foot = date("H:i:sO",$val);
			$lastmod = $lastmod_head . "T" . $lastmod_foot;
			$meta = get_meta_tags($link);
			$meta[description] = mb_convert_encoding($meta[description], "UTF-8", "auto");

			$title = get_title($url,$link);

			if ($output_mode == "rss1") {
				$XML[] = "\t<item rdf:about=\"$link\">\n";
			} elseif ($output_mode == "rss2") {
				$XML[] = "\t<item>\n";
			} elseif ($output_mode == "atom") {
				$XML[] = "\t<entry>\n";
			}
			$XML[] = "\t\t<title>$title</title>\n";
			if ($output_mode == "rss1"||$output_mode == "rss2") { $XML[] = "\t\t<link>$link</link>\n"; }
			elseif ($output_mode == "atom") { $XML[] = "\t\t<link rel=\"alternate\" type=\"text/html\" href=\"$link\" />\n"; }
			if ($output_mode == "rss1" || $output_mode == "rss2") {
				$XML[] = "\t\t<description>$meta[description]</description>\n";
			} elseif ($output_mode == "atom") {
				$XML[] = "\t\t<summary>$meta[description]</summary>\n";
			}
			if ($output_mode == "rss1") {
				$XML[] = "\t\t<dc:date>$lastmod</dc:date>\n";
			} elseif ($output_mode == "rss2") {
				$XML[] = "\t\t<pubDate>$lastmod</pubDate>\n";
			} elseif ($output_mode == "atom") {
				$XML[] = "\t\t<published>$lastmod</published>\n\n";
			} 
			if ($output_mode == "rss1" || $output_mode == "rss2") {
				$XML[] = "\t</item>\n";
			} elseif ($output_mode == "atom") {
				$XML[] = "\t</entry>\n";
			}
			$XML[] = "\t\n\n";
		}
		if ($output_mode == "rss1") {
			$XML[] = "</rdf:RDF>\n";
		}
	}

	if ($output_mode == "rss2") {
		$XML[] = "\t</channel>\n";
		$XML[] = "</rss>\n\n";
	} elseif ($output_mode == "atom") {
		$XML[] = "</feed>\n\n";
	}

	if ($XML) {
		$out_path = $out_dir . $sitemap;
		if ($fno = fopen("$out_path", 'w')) {
			foreach ($XML as $val) {
				fwrite($fno, $val, 150000);
			}
		} else {
			$msg .= "<p style=\"color:#cc0000\">RSS1.0出力に失敗しました。</p>\n";
		}
		fclose($fno);
	}
	if (!$msg) { $msg = "<p>RSS1.0が作成されました。<br><a href=\"$out_path\" target=\"_blank\">$out_path</a></p>"; }
	else { $error = 1; }
	return array($msg,$error);

}

function get_title($url,$link){
	$fno = fopen(ereg_replace($url,"./",$link), 'r');
	$title_start = $title_end = 0;
	while (!feof($fno)) {
		$line = fgets($fno, 32000);
		if (eregi("<title>",$line)) {
			$line = eregi_replace("<title>","",$line);
			$line = trim($line);
			$title_start = 1;
		}
		if ($title_start == 1 && eregi("</title>",$line)) {
			$line = eregi_replace("</title>","",$line);
			$line = trim($line);
			$title_end = 1;
		}
		if ($title_start == 1) {
			$title = $line;
		}
		if ($title_end == 1) { break; }
	}
	fclose($fno);
	$title = mb_convert_encoding($title, "UTF-8", "auto");
	return $title;
}


?>
